package main

func delta(in chan int, out1 chan int, out2 chan int) {
    for i:= 0; i < 20000; i++ {
        a := <- in
        out1 <- a
        out2 <- a
    }
}

func succ(in chan int, out chan int) {
    for i := 0; i < 20000; i++ {
        a := <- in 
        a++
        out <- a
    }
}

func consume(in chan int) {
    for i := 0; i < 20000; i++ {
        a := <- in
        a++
    }
}


func main() {
    chan_a := make(chan int)
    chan_b := make(chan int)
    chan_c := make(chan int)
    chan_d := make(chan int)
    go delta(chan_a, chan_b, chan_c)
    go succ(chan_b, chan_d)
    go consume(chan_c)

    chan_a <- 1
    for i:= 1; i < 20000; i ++ {
        a := <- chan_d
        chan_a <- a
    }
}

